/*
Program Memory Usage 	:	23358 bytes   71,3 % Full
Data Memory Usage 		:	1352 bytes    66,0 % Full
EEPROM Memory Usage 	:	406 bytes     39,6 % Full
*/

// Einbinden diverse Dateien
#include "SI4735.h"
#include "i2c.c"
#include "lcd.c"
#include "lcd.h"
#include "math.h"
#include "defi.h"
#include "eingabe.c"
#include "RDS.c"
#include "LCD_COMMANDS.C"
#include "TUNER.c"
#include <avr/wdt.h>
#include <avr/eeprom.h>



/* Variablen */

// EEPROM Speicher //
unsigned int eeFooWordspeicher1 EEMEM; // Speicherplatz fr den Sender Frequenzmodulation (UKW)
unsigned int eeFooWordspeicher2 EEMEM; // Speicherplatz fr den Zustand "AN/AUS"
unsigned int eeFooWordspeicher3 EEMEM; // Speicherplatz fr die Lautstrke
unsigned int eeFooWordspeicher4 EEMEM; // Speicherplatz fr den Zustand der Hintergrundbeleuchtung
unsigned int eeFooWordspeicher5 EEMEM; // Speicherplatz merker 3
unsigned int eeFooWordspeicher6 EEMEM; // Speicherplatz fr den Sender_2 fr Amplitudenmodulation (MW, LW, KW)
unsigned int eeFooWordspeicher7 EEMEM; // Speicherplatz fr einen Zwischenspeicher im Bandwahlbereich fr Amplitudenmodulation (MW, LW, KW)
unsigned int eeFooWordspeicher8 EEMEM; // Speicherplatz fr den Sender_3
unsigned int eeFooWordspeicher9 EEMEM; // Speicherplatz fr den Sender_4
unsigned int eeFooWordspeicher10 EEMEM; // Speicherplatz fr den Sender_5
unsigned int eeFooWordspeicher11 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher12 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher13 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher14 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher15 EEMEM; // Speicherplatz fr 
unsigned int eeFooWordspeicher16 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher17 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher18 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher19 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher20 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher21 EEMEM; // Speicherplatz fr channel_seek
unsigned int eeFooWordspeicher22 EEMEM; // Speicherplatz fr channel_seek




// Werte fr den Inkrementalgeber //
signed char coder; // Dies ist fr den Sender zustndig (Zahlenbereich 0....255 mit Vorzeichen)
signed char coder_2; // Dies ist fr die Lautstrke zustndig (Zahlenbereich 0....255 mit Vorzeichen)
signed char coder_3; // Dies ist fr AM Zustndig
unsigned char zsp; // Dies ist fr den Sender zustndig (Zahlenbereich 0....65535 ohne Vorzeichen)
unsigned char zsp_2; // Dies ist fr den Lautstrke zustndig (Zahlenbereich 0....255 ohne Vorzeichen)
unsigned char zsp_3; // Dies ist fr dem AM Bereich
unsigned char zsp_4; //
unsigned char zsp_5; //
signed char zsp_7; //
unsigned char zsp_Sender_5;
unsigned char zsp_Sender_4;
unsigned char zsp_Sender_3;
unsigned char zsp_Sender_2;
unsigned int zsp_Sender_AUTO;
unsigned char Gueltigkeitsbit;

// Variable fr den SI4735
unsigned char volume; // Dies ist fr den Lautstrkebereich zustndig (Zahlenbereich 0....255 ohne Vorzeichen)

// Empfangsspeicher 8-bit //
//unsigned char status_2;
//unsigned char status;
//unsigned char status_RDS;
unsigned char resp1;
unsigned char resp2;
unsigned char resp3;
unsigned char resp4;
unsigned char resp4_2;
unsigned char resp5;
unsigned char resp5_2;
unsigned char resp6;
unsigned char resp7;
signed char resp7_2;
unsigned char resp8;
unsigned char resp9;
unsigned char resp10;
unsigned char resp11;
unsigned char resp12;
unsigned int Sender; // 16-bit
unsigned int Sender_2; // AM
unsigned int Sender_3; // MW
unsigned int Sender_4; // LW
unsigned int Sender_5; // KW
unsigned int tuning;
unsigned int channel_seek;
//unsigned int version;
//unsigned int s;
//unsigned int i;
//unsigned int x=0;
//unsigned char temp;
//signed int pos;
int Auswahl;
unsigned int Switch_SM;
char DE;
char stereo;
char mono;
char Schritt;
char RSSI;
char SNR;
char merker_7;
int Zoegerung=8;

unsigned int H_FREQ;
unsigned int L_FREQ;
unsigned int Speicherplatz[20] EEMEM;
unsigned int PS_Save[8][20] EEMEM;
int merker_8;
unsigned int Buffer_3;
unsigned int Buffer_4;
unsigned int Speichern EEMEM;
int repeat;

void GET_FM_DOWNSIDE_FREQ(unsigned int *);// Prototyp notwendig, da erst Hauptprogramm und anschlieend das Unterprogramm folgt
void GET_FM_UPPERSIDE_FREQ(unsigned int *);// Prototyp notwendig, da erst Hauptprogramm und anschlieend das Unterprogramm folgt
void CALL_FM_RSQ_DATA(unsigned char *, unsigned char *, signed char *, unsigned char *);// Prototyp notwendig, da erst Hauptprogramm und anschlieend das Unterprogramm folgt
void CLEAR_LINE (int */*X_LINE*/, int */*Y_LINE*/, int */*DELTA_X_LINE*/, int */*DELTA_Y_LINE*/);
void LCD_START ();
int X_LINE;
int Y_LINE;
int DELTA_X_LINE;
int DELTA_Y_LINE;
unsigned char resp3_2;

int main(void)
{
	
	// Den Variablen wird ein Wert zugewiesen //
	Sender = 8750; // Ausgangswert fr die Variable "Sender"
	Sender_2 = 150;// Ausgangswert fr die Variable "Sender_2"
	Sender_3 = 522;//Ausgangswert fr die Variable "Sender_3"
	Sender_4 = 150;//Ausgangswert fr die Variable "Sender_4"
	Sender_5 = 2300;//Ausgangswert fr die Variable "Sender_4"
	volume = 20; // Ausgangswert fr die Variable "volume"
	unsigned int merker_1=0; // Ausgangswert fr die Variable "merker_1"
	unsigned int merker_2=0; // Ausgangswert fr die Variable "merker_2"
	unsigned int merker_3=0; // Ausgangswert fr die Variable "merker_3"
	unsigned int merker_4=0; // Ausgangswert fr die Variable "merker_4"
	unsigned int merker_5=0; // Ausgangswert fr die Variable "merker_5"
	unsigned int merker_6=0; // Ausgangswert fr die Variable "merker_6"
	tuning = 0;
	channel_seek = 0;

	
	/* Initialisierungen bezglich Eingabe & Kommunikation */
	/* Hier werden die Eingabeports fr die Tasten initialisiert */
	PORTD |= (1<<PD0) | (1<<PD1) | (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5) | (1<<PD6) | (1<<PD7); /* Hier werden die Eingabeports fr die Tasten initialisiert */
	PORTA |= (1<<PA5) | (1<<PA6); /* Hier werden die Eingabeports fr die Tasten initialisiert */
	
	// Hier wird der Port fr die Hintergrundbeleuchtung mit der aufgefhrten Pinnummer definiert //
	DDRA |= (1<<PA2) | (1<<PA3) | (1<<PA7); /* Tastaturbeleuchtung Inkrementalgeber 1 / Tasten /Inkrementalgeber 2 */
	DDRB |= (1<<PB0); /* Hintergrundbeleuchtung LCD */
	
	//I2C Bus //
	init_i2c();      // I2C wird fr die Verwendung initialisiert
	
	//Inkrementalgeber //
	encode_init_1(); // Der Inkrementalgeber 1 wird fr die Verwendung initialisiert (Fr die Bedienung der Sender)
	encode_init_2(); // Der Inkrementalgeber 2 wird fr die Verwendung initialisiert (Fr die Bedienung der Lautstrke)
	LCD_START (); // LCD via Funktion aktivieren
	
	
	// Hier werden einige Daten gelesen, um den letzten Zustand des Radios, nach einer Unterbrechung, wiederherzustellen //
	// char Radiotext [64]; // Speicherort bis zu 20 Zeichen
	char Buffer [20]; // Speicherort bis zu 20 Zeichen
	char Buffer_2 [20]; // Speicherort bis zu 20 Zeichen
	char Buffer_5 [20];
	Sender = eeprom_read_word(&eeFooWordspeicher1); // Stellt den letzten Sender wieder ein
	merker_1 = eeprom_read_word(&eeFooWordspeicher2); // Nach einer Unterbrechung (Absturz, Stromausfall) wird hier berprft, ob das Radio an oder aus war
	volume = eeprom_read_word(&eeFooWordspeicher3); // Hier wird die letzte Lautstrke wiederhergestellt
	merker_2 = eeprom_read_word(&eeFooWordspeicher4); // Nach einer Unterbrechung (Absturz, Stromausfall) wird hier berprft, ob das Radio auf FM oder AM eingestellt war
	merker_3 = eeprom_read_word(&eeFooWordspeicher5); // Nach einer Unterbrechung (Absturz, Stromausfall) wird hier berprft, ob das Radio auf FM oder AM eingestellt war
	Sender_2 = eeprom_read_word(&eeFooWordspeicher6); // Stellt den letzten Sender wieder ein
	merker_4 = eeprom_read_word(&eeFooWordspeicher7); // Wichtig
	Sender_3 = eeprom_read_word(&eeFooWordspeicher8); // Stellt den letzten Sender wieder ein
	Sender_4 = eeprom_read_word(&eeFooWordspeicher9); // Stellt den letzten Sender wieder ein
	Sender_5 = eeprom_read_word(&eeFooWordspeicher10); // Stellt den letzten Sender wieder ein
	channel_seek = eeprom_read_word(&eeFooWordspeicher11); // Suchlauf oder Handeinstellung
	merker_5 = eeprom_read_word(&eeFooWordspeicher12); // Suchlauf oder Handeinstellung
	merker_6 = eeprom_read_word(&eeFooWordspeicher13); // Suchlauf oder Handeinstellung
	stereo = eeprom_read_word(&eeFooWordspeicher14); // Speichert den Stereowert
	mono = eeprom_read_word(&eeFooWordspeicher15); // Speichert den Monowert
	Schritt = eeprom_read_word(&eeFooWordspeicher16); // Suchlauf oder Handeinstellung
	RSSI = eeprom_read_word(&eeFooWordspeicher17); // Speichert den Stereowert
	SNR = eeprom_read_word(&eeFooWordspeicher18); // Speichert den Monowert
	merker_7 = eeprom_read_word(&eeFooWordspeicher19); // Suchlauf oder Handeinstellung
	H_FREQ = eeprom_read_word(&eeFooWordspeicher20); // Speichert den Monowert
	L_FREQ = eeprom_read_word(&eeFooWordspeicher21); // Suchlauf oder Handeinstellung

	//FM Senderspeicher
	/*signed int z;
	z=10;*/
	lcd_gotoxy(0,2);
	lcd_puts("   SUCSESSFULL!! ");
	while(1)
	{
		
		if ((!(PIND&(1<<PD5))&&(merker_1==0))) // Einschalten
		{
			merker_1=1;
			merker_4=0;
			_delay_ms(400);
			wdt_reset();
		}
		if((merker_1==1)&&(merker_4==0)&&(merker_2==0))
		{
			lcd_gotoxy(4, 1 );
			lcd_puts("   SI4735   ");
			lcd_gotoxy(11, 1 );
			
			lcd_gotoxy(0, 0 );
			lcd_puts(" WORLDBAND-RECEIVER ");
			
			lcd_gotoxy(0, 2 );
			lcd_puts("Firmware Ver.: 1.30");
			lcd_gotoxy(1, 3 );
			lcd_puts("LED BAND  RDS  MENU");
		}
		//TEST MENU
		if((!(PIND&(1<<PD3)))&&(merker_1==1))
		{
			lcd_clrscr();
			Auswahl &= 0x02;
			Switch_SM &= 0x01;
			merker_4=2;
			_delay_ms(800);
		}
			while((merker_4==2)&&(merker_6==0)&&(merker_7==0))
			{
				coder = encode_read_1();
				Auswahl += coder;
				lcd_gotoxy(0,0);
				lcd_puts("RADIO-SETUP-MENU:");
				if(Auswahl>4)Auswahl=0;
				if(Auswahl<0)Auswahl=4;
				if(Auswahl<=2)
				{
					lcd_gotoxy(2,1);
					lcd_puts("Stereo/Mono Umsch.");
					lcd_gotoxy(2,2);
					lcd_puts("Auto-Search Mod.");
					lcd_gotoxy(2,3);
					lcd_puts("Info");
				}
				if(Auswahl>2)
				{
					lcd_gotoxy(2,1);
					lcd_puts("RDS Options       ");
					lcd_gotoxy(2,2);
					lcd_puts("Exit              ");
					
					X_LINE=0;Y_LINE=3;DELTA_X_LINE=20;DELTA_Y_LINE=1;
					CLEAR_LINE (&X_LINE,&Y_LINE,&DELTA_X_LINE,&DELTA_Y_LINE);
				}
				switch(Auswahl)
				{
					case 0:	lcd_gotoxy(0,1); // Stereo Mono
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6)))
					{
						lcd_clrscr();
						merker_6=1;
						_delay_ms(500);
					}
						break;
					
					case 1: lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  "); 
					
					if(!(PIND&(1<<PD6)))
					{
						lcd_clrscr();
						merker_6=2;
						_delay_ms(500);
					}
					
					break;
					
					case 2: lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("->");
					if(!(PIND&(1<<PD6)))
					{
					lcd_clrscr();
					merker_6=3;
					_delay_ms(500);
					}
					 break;
					
					case 3:
					lcd_gotoxy(0,1); // Stereo Mono
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6)))
					{
						lcd_clrscr();
						merker_6=4;
						_delay_ms(500);
					}
					break;
					
					case 4:
					lcd_gotoxy(0,2); // Stereo Mono
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						merker_6=0;
						merker_4=0;
						if(merker_2==2)repeat=1;
						lcd_clrscr();}break;
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					lcd_clrscr();
					lcd_gotoxy(0,2); // Mono
					lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					merker_6=0;
					merker_4=0;
					if(merker_2==2)repeat=1;
					lcd_clrscr();
				}
			}
			while(merker_6==1)//Stereo u. Mono umschalten
			{
				lcd_gotoxy(0,0);
				lcd_puts("Stereo/Mono waehlen:");
				lcd_gotoxy(2,1);
				lcd_puts("Stereo Mode");
				lcd_gotoxy(2,2);
				lcd_puts("Mono Mode");
				lcd_gotoxy(2,3);
				lcd_puts("Full Stereo Mode");
				coder = encode_read_1();
				Switch_SM+=coder;
				if(Switch_SM>2)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=2;
				switch(Switch_SM)
				{
					case 0:	lcd_gotoxy(0,1); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						stereo=38;
						mono=20;
						AUDIO_MODE (stereo, mono);
						eeprom_write_word (&eeFooWordspeicher14, stereo);
						eeprom_write_word (&eeFooWordspeicher15, mono);
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						wdt_reset();
						_delay_ms(800);
						lcd_clrscr();
						merker_6=0;}break;
					
					case 1: lcd_gotoxy(0,2); // Mono
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						stereo=127;
						mono=127;
						AUDIO_MODE (stereo, mono);
						eeprom_write_word (&eeFooWordspeicher14, stereo);
						eeprom_write_word (&eeFooWordspeicher15, mono);
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
						merker_6=0;}break;
					
					case 2:	lcd_gotoxy(0,3); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						stereo=0;
						mono=0;
						AUDIO_MODE (stereo, mono);
						eeprom_write_word (&eeFooWordspeicher14, stereo);
						eeprom_write_word (&eeFooWordspeicher15, mono);
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
						merker_6=0;}break;
					
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					lcd_clrscr();
					merker_6=0;
				}
			}
			
			while((merker_6==2)&&(merker_7==0))
			{
				lcd_gotoxy(0,0);
				lcd_puts("Auto Search Modus:  ");
				lcd_gotoxy(2,1);
				lcd_puts("Suchlaufschritt");
				lcd_gotoxy(2,2);
				lcd_puts("Suchlaufempfindl.");
				lcd_gotoxy(2,3);
				lcd_puts("Empfangsort");
				coder = encode_read_1();
				Switch_SM+=coder;
				if(Switch_SM>2)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=2;
				switch(Switch_SM)
				{
					case 0:	lcd_gotoxy(0,1); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6)))
					{
						lcd_clrscr();
						merker_7=1;
						_delay_ms(500);
					}break;
					
					case 1: lcd_gotoxy(0,2); // Mono
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6)))
					{
						lcd_clrscr();
						merker_7=2;
						_delay_ms(500);
					}break;
					
					case 2: lcd_gotoxy(0,3); // Mono
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6)))
					{
						lcd_clrscr();
						merker_7=3;
						_delay_ms(500);
					}break;
					
					
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					lcd_clrscr();
					merker_6=0;
				}
			}
			while(merker_6==3)
			{
				coder = encode_read_1();
				Switch_SM+=coder;
				if(coder!=0)lcd_clrscr();
				if(Switch_SM>1)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=1;
				switch(Switch_SM)
				{
				case 0:
				lcd_gotoxy(0, 0 );
				lcd_puts(" WORLDBAND-RECEIVER ");
				lcd_gotoxy(0, 2 );
				lcd_puts("Firmware Ver.: 1.30T");
				lcd_gotoxy(0, 3 );
				lcd_puts("by Savas Saffak 2014");
				if(!(PIND&(1<<PD6))){lcd_clrscr();
					_delay_ms(800);
					lcd_clrscr();
					merker_6=0;}
				break;
				case 1:
				lcd_gotoxy(0, 0 );
				lcd_puts("MORE INFORMATIONS:");
				lcd_gotoxy(0, 1 );
				lcd_puts("Build Date: 20.03.14");
				lcd_gotoxy(0, 2 );
				lcd_puts("RDS:RT,PS,PI-CODE");
				lcd_gotoxy(0, 3 );
				lcd_puts("Auto Seek, Ch memory");
				
				if(!(PIND&(1<<PD6))){lcd_clrscr();
				_delay_ms(800);
				wdt_reset();
				lcd_clrscr();
				merker_6=0;}
				break;
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					lcd_clrscr();
					merker_6=0;
				}
			}
			
			while(merker_6==4)
			{
				coder = encode_read_1();
				Switch_SM+=coder;
				if(coder!=0)lcd_clrscr();
				if(Switch_SM>1)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=1;
				lcd_gotoxy(0, 0 );
				lcd_puts("RDS OPTIONS:");
				lcd_gotoxy(3, 1 );
				lcd_puts("RDS ON");
				lcd_gotoxy(3, 2 );
				lcd_puts("RDS OFF");
				switch(Switch_SM)
				{
					case 0:
					lcd_gotoxy(0,1); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					
					if(!(PIND&(1<<PD6))){lcd_clrscr();
					merker_5=1;
					eeprom_write_word (&eeFooWordspeicher12, merker_5);
					lcd_gotoxy( 2, 1 );
					lcd_puts("   RDS ON   ");
					_delay_ms(1000);
					RDS_SET_ON();
					_delay_ms(10);
					wdt_reset();
					_delay_ms(800);
					lcd_clrscr();
					PROGRAMM_SERVICE();
					merker_6=0;}
					break;
					
					case 1:
					lcd_gotoxy(0,2); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
					merker_5=0;
					eeprom_write_word (&eeFooWordspeicher12, merker_5);
					lcd_gotoxy( 0, 1 );
					lcd_puts("     RDS OFF        ");
					_delay_ms(1400);
					RDS_SET_OFF();
					RDS_CLEAR();
					_delay_ms(10);
					wdt_reset();
					_delay_ms(800);
					lcd_clrscr();
					merker_6=0;}
					break;
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					wdt_reset();
					lcd_clrscr();
					merker_6=0;
				}
			}
			while(merker_7==1)//Suchlaufschritt Untermenu!!
			{
				lcd_gotoxy(0,0);
				lcd_puts("Suchlaufschritt:");
				lcd_gotoxy(2,1);
				lcd_puts(" 50 kHz Schritt");
				lcd_gotoxy(2,2);
				lcd_puts("100 kHz Schritt");
				lcd_gotoxy(2,3);
				lcd_puts("200 kHz Schritt");
				coder = encode_read_1();
				Switch_SM+=coder;
				if(Switch_SM>2)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=2;
				switch(Switch_SM)
				{
					case 0:	lcd_gotoxy(0,1); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						Schritt=5;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher16, Schritt);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;}break;
					
					case 1: lcd_gotoxy(0,2); // Mono
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						Schritt=10;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher16, Schritt);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;}break;
					
					case 2:	lcd_gotoxy(0,3); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){Schritt=20;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher16, Schritt);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;}break;
					
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;
				}
			}
			
			while(merker_7==2)//Suchlaufempfindlichkeit
			{
				
				lcd_gotoxy(0,0);
				lcd_puts("Suchlaufempfind:");
				lcd_gotoxy(2,1);
				lcd_puts("Stadtbereich: LOW");
				lcd_gotoxy(2,2);
				lcd_puts("Auf dem Land: MID");
				lcd_gotoxy(2,3);
				lcd_puts("Gebirge: HIGH");
				coder = encode_read_1();
				Switch_SM+=coder;
				if(Switch_SM>2)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=2;
				switch(Switch_SM)
				{
					case 0:	lcd_gotoxy(0,1); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						RSSI=30;
						SNR=30;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher17, RSSI);
						eeprom_write_word (&eeFooWordspeicher18, SNR);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;}break;
					
					case 1: lcd_gotoxy(0,2); // Mono
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						RSSI=20;
						SNR=20;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher17, RSSI);
						eeprom_write_word (&eeFooWordspeicher18, SNR);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;}break;
					
					case 2:	lcd_gotoxy(0,3); // Stereo
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){
						RSSI=10;
						SNR=8;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher17, RSSI);
						eeprom_write_word (&eeFooWordspeicher18, SNR);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;}break;
					
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;
				}
			}
			
			while(merker_7==3)//Empfangsort
			{
				
				lcd_gotoxy(0,0);
				lcd_puts("Empfangsort-Radio:");
				if(Switch_SM<=2)
				{
				lcd_gotoxy(2,1);
				lcd_puts("Eu: 87,5 bis 108,0");
				lcd_gotoxy(2,2);
				lcd_puts("Ch: 76,0 bis 90,0 ");
				lcd_gotoxy(2,3);
				lcd_puts("Ru: 64,0 bis 76,0 ");
				}
				if(Switch_SM>2)
				{
					lcd_gotoxy(2,1);
					lcd_puts("Wo: 64,0 bis 108,0");
					lcd_gotoxy(2,2);
					lcd_puts("En: 88,0 bis 107,9");
					lcd_gotoxy(2,3);
					lcd_puts("US: 87,9 bis 107,9");
				}
				coder = encode_read_1();
				Switch_SM+=coder;
				if(Switch_SM>5)Switch_SM=0;
				if(Switch_SM<0)Switch_SM=5;
				switch(Switch_SM)
				{
					case 0:	lcd_gotoxy(0,1); // Europa
					lcd_puts("->");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						H_FREQ=10800;
						L_FREQ=8750;
						DE=1;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher20, H_FREQ);
						eeprom_write_word (&eeFooWordspeicher21, L_FREQ);
						eeprom_write_word (&eeFooWordspeicher22, DE);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
					merker_7=0;}break;
					
					case 1: lcd_gotoxy(0,2); // China
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){lcd_clrscr();
						H_FREQ=9000;
						L_FREQ=7600;
						DE=1;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher20, H_FREQ);
						eeprom_write_word (&eeFooWordspeicher21, L_FREQ);
						eeprom_write_word (&eeFooWordspeicher22, DE);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
					merker_7=0;}break;
					
					case 2:	lcd_gotoxy(0,3); // Russland
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){
						H_FREQ=7600;
						L_FREQ=6400;
						DE=1;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher20, H_FREQ);
						eeprom_write_word (&eeFooWordspeicher21, L_FREQ);
						eeprom_write_word (&eeFooWordspeicher22, DE);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
					merker_7=0;}break;
					
					case 3:	lcd_gotoxy(0,1); // World
					lcd_puts("->");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){
						H_FREQ=10800;
						L_FREQ=6400;
						DE=1;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher20, H_FREQ);
						eeprom_write_word (&eeFooWordspeicher21, L_FREQ);
						eeprom_write_word (&eeFooWordspeicher22, DE);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
					merker_7=0;}break;
					
					case 4:	lcd_gotoxy(0,2); // England
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,3);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){
						H_FREQ=10790;
						L_FREQ=8800;
						DE=1;
						SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
						eeprom_write_word (&eeFooWordspeicher20, H_FREQ);
						eeprom_write_word (&eeFooWordspeicher21, L_FREQ);
						eeprom_write_word (&eeFooWordspeicher22, DE);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
					merker_7=0;}break;
					
					case 5:	lcd_gotoxy(0,3); // USA
					lcd_puts("->");
					lcd_gotoxy(0,1);
					lcd_puts("  ");
					lcd_gotoxy(0,2);
					lcd_puts("  ");
					if(!(PIND&(1<<PD6))){
					H_FREQ=10790;
					L_FREQ=8790;
					DE=2;
					SEARCH_LIMIT_DEFINITIONS(Schritt, RSSI, SNR, H_FREQ, L_FREQ, DE);
					eeprom_write_word (&eeFooWordspeicher20, H_FREQ);
					eeprom_write_word (&eeFooWordspeicher21, L_FREQ);
					eeprom_write_word (&eeFooWordspeicher22, DE);
						lcd_clrscr();
						lcd_gotoxy(0,2); // Mono
						lcd_puts("INITIALISIEREN...");
						_delay_ms(800);
						lcd_clrscr();
					merker_7=0;}break;
					
				}
				wdt_reset();
				if(!(PIND&(1<<PD3)))
				{
					_delay_ms(800);
					lcd_clrscr();
					merker_7=0;
				}
			}
			
		wdt_enable(WDTO_2S); // Aktiviere den Wachhund! Beim Aufhngen des Controllers wird nach 2 Sekunden ein Reset-Interrupt ausgelst
		if (!(PIND&(1<<PD5))&&((merker_1==1))) // Ausschalten
		{
			TURN_OFF();
			wdt_reset();
			_delay_ms(100);
			wdt_reset();
			eeprom_write_word (&eeFooWordspeicher1, Sender);
			//Alle Zeichen lschen
			lcd_clrscr();
			lcd_gotoxy(4, 1 );
			lcd_puts("**STANDBY**");
			lcd_gotoxy(4, 2 );
			lcd_puts("**GOODBYE**");
			_delay_ms(1000);
			wdt_reset();
			_delay_ms(1000);
			wdt_reset();
			PORTB &= ~(1<<PB0);
			PORTA &= ~(1<<PA2);
			PORTA &= ~(1<<PA3);
			PORTA &= ~(1<<PA7);
			PORTB &= ~(1<<PB0);
			lcd_clrscr();
			_delay_ms(100);
			wdt_reset();
			merker_1 = 0;
			merker_2 = 0;
			merker_4 = 1;
			eeprom_write_word (&eeFooWordspeicher2, merker_1);
			eeprom_write_word (&eeFooWordspeicher4, merker_2);
			eeprom_write_word (&eeFooWordspeicher5, merker_3);
		}
		if (merker_1==1) // HAUPTSCHLEIFE "BANDAUSWAHL"
		{
			if (merker_3==0) // Beleuchtung
			{
				PORTB |= (1<<PB0);
				PORTA |= (1<<PA2);
				PORTA |= (1<<PA3);
				PORTA |= (1<<PA7);
				
				if (!(PIND&(1<<PD0)))
				{
					merker_3=1;
					eeprom_write_word (&eeFooWordspeicher5, merker_3);
					_delay_ms(400);
					wdt_reset();
				}
			}
			if (merker_3==1)
			{
				PORTB |= (1<<PB0);
				PORTA &= ~(1<<PA2);
				PORTA &= ~(1<<PA3);
				PORTA &= ~(1<<PA7);
				if (!(PIND&(1<<PD0)))
				{
					merker_3=2;
					eeprom_write_word (&eeFooWordspeicher5, merker_3);
					_delay_ms(400);
					wdt_reset();
				}
			}
			
			if (merker_3==2)
			{
				PORTB &= ~(1<<PB0);
				PORTA &= ~(1<<PA2);
				PORTA &= ~(1<<PA3);
				PORTA &= ~(1<<PA7);
				if (!(PIND&(1<<PD0)))
				{
					merker_3=0;
					eeprom_write_word (&eeFooWordspeicher5, merker_3);
					_delay_ms(400);
					wdt_reset();
				}
			}
			if (!(PIND&(1<<PD1)))
			{
				merker_4 = 1;
				eeprom_write_word (&eeFooWordspeicher7, merker_4);
				_delay_ms(100);
				wdt_reset();
				lcd_clrscr();
				lcd_gotoxy(0, 0 );
				lcd_puts(" WORLDBAND-RECEIVER ");
				lcd_gotoxy(0, 2 );
				lcd_puts("EMPFANGSBAND WAEHLEN");
				lcd_gotoxy(2, 3);
				lcd_puts("FM");
			}
			if ((merker_4==1)||(repeat==1))
			{
				_delay_ms(100);
				wdt_reset();
				if ((!(PIND&(1<<PD0)))||(repeat==1)) // FM Modus
				{
					merker_4=0;
					repeat=0;
					eeprom_write_word (&eeFooWordspeicher7, merker_4);
					lcd_clrscr();
					lcd_gotoxy(0, 2 );
					lcd_puts("INITIALISIERUNG.....");
					lcd_gotoxy(0, 1 );
					lcd_puts("BITTE WARTEN SIE....");
					eeprom_write_word (&eeFooWordspeicher4, merker_2);
					if (merker_2!=2) // Unter der Bedingung, dass der Radio sich nicht im FM Band befindet!
					{	
						TURN_ON_AND_DEFINITIONS();
						wdt_reset();	
						AUDIO_MODE (stereo, mono);
						wdt_reset();
						SEARCH_LIMIT_DEFINITIONS(Schritt,RSSI,SNR,H_FREQ,L_FREQ, DE);
						wdt_reset();
						TUNING_OPTIONS();
						wdt_reset();
						VOLUME_SET(volume);
						wdt_reset();
						RDS_SET_ON();
						wdt_reset();
						merker_2=2;
						eeprom_write_word (&eeFooWordspeicher4, merker_2);
					}
					_delay_ms(100);
					wdt_reset();
					lcd_clrscr(); //Alle Zeichen lschen
					_delay_ms(50);
					wdt_reset();
					Sender = eeprom_read_word (&eeFooWordspeicher1); // Stellt den letzten Sender wieder ein
					merker_3 = eeprom_read_word (&eeFooWordspeicher5); // Nach einer Unterbrechung (Absturz, Stromausfall) wird hier berprft, ob die Beleuchtung an oder aus war
					eeprom_write_word (&eeFooWordspeicher2, merker_1);
					merker_2=2;
					lcd_gotoxy(5, 0 );
					if (channel_seek==0)
					{
						lcd_gotoxy(0, 0 );
						lcd_puts("FM MANUELL ");
					}
					if (channel_seek==1)
					{
						lcd_gotoxy(0, 0 );
						lcd_puts("FM AUTO   ");
					}
					if (channel_seek==2)
					{
						lcd_gotoxy(0, 0 );
						lcd_puts("FM MEMORY ");
					}
					
					lcd_gotoxy(0, 2 );
					lcd_puts("FM: ");
					utoa( (Sender/100), Buffer, 10 );
					lcd_puts(Buffer);
					lcd_puts(".");
					Buffer_4=Sender;
					utoa(Buffer_4%100,Buffer_2,10);
					if((Buffer_4%100)==0)lcd_puts("00");
					if(Buffer_4%100==5)lcd_puts("05");
					if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
					lcd_puts(Buffer_2);lcd_puts(" MHz ");lcd_puts(" ");
					_delay_ms(40);
					wdt_reset();
					lcd_gotoxy( 13, 3 );
					lcd_puts("RSSI");
					lcd_gotoxy( 18, 3 );
					lcd_puts(" ");
					lcd_gotoxy( 17, 3 );
					itoa( resp4_2, Buffer, 10 );
					lcd_puts(Buffer);
					wdt_reset();
					lcd_gotoxy( 7, 3 );
					lcd_puts("SNR");
					lcd_gotoxy( 11, 3 );
					lcd_puts(" ");
					lcd_gotoxy( 10, 3 );
					itoa( resp5_2, Buffer, 10 );
					lcd_puts(Buffer);
					wdt_reset();
					if (((resp7_2 < 50) && (resp7_2 > -50)) && (resp4_2 > 15) && (resp5_2 > 10))
					{
						lcd_gotoxy(15,2);
						lcd_puts("TUNED");
					}
					wdt_reset();
					lcd_gotoxy( 0, 3 );
					lcd_puts("TUN");
					lcd_gotoxy( 3, 3 );
					lcd_puts("    ");
					lcd_gotoxy( 3, 3 );
					itoa( resp7_2, Buffer_2, 10 );
					lcd_puts(Buffer_2);
					
					if((resp3>=150) && (resp3<=255)&&(stereo!=127)&&(mono!=127))
					{
						lcd_gotoxy(11, 0 );
						lcd_puts("   STEREO");
					}
					if((resp3>=20) && (resp3<=150)&&(stereo!=127)&&(mono!=127))
					{
						lcd_gotoxy(11, 0 );
						lcd_puts("ST. BLEND");
					}
					if((resp3<=1)||((stereo==127)&&(mono==127)))
					{
						lcd_gotoxy(11, 0 );
						lcd_puts("     MONO");
					}
				}
			}
			


			
			
			if ((merker_4!=1)&&(merker_4!=2)&&(merker_4!=3))
			{
				if (merker_2==2) // FM SCHLEIFE
				{
					// Hier wird die Lautstrkeregelung unabhngig von den anderen Empfangsbandarten eingestellt
					// Unter anderem wird hier die Frequenzskala eingestellt und definiert
					coder_2 = encode_read_2();
					volume += coder_2 * 2;
					if(zsp_2 != volume){Zoegerung=0;lcd_gotoxy(0,1); lcd_puts("                    ");} 
					while((zsp_2 != volume)||(Zoegerung<8))
					{
						Zoegerung++;
						coder_2 = encode_read_2();
						volume += coder_2 * 2;
						if (volume>=61)
						{volume=60;}
						
						if (volume<=9)
						{volume=10;}
						
						zsp_2 = volume;
						VOLUME_SET(volume);
						_delay_ms(2);
						eeprom_write_word (&eeFooWordspeicher3, volume);
						_delay_ms(4);
						CALL_FM_RSQ_DATA(&zsp_4, &zsp_5, &zsp_7, &zsp_3);
						if(merker_5!=0)RDS_SET_OFF();//Wenn RDS aus ist, dann nicht ausblenden, bzw. erneut einschalten
						wdt_reset();
						utoa(((volume/2.)-5),Buffer_2,10);
						lcd_gotoxy(3,1);
						lcd_puts("Lautstaerke ");
						lcd_puts(Buffer_2);lcd_puts(" ");//Zum lschen der Zeichen, da linksbndige Ausgabe!!
						if((merker_5!=0)&&(Zoegerung==8)){lcd_gotoxy(0,1); lcd_puts("                    ");}
						if((merker_5!=0)&&(Zoegerung==8))RDS_SET_ON();
						wdt_reset();
					}

					
					if(((zsp_4!=resp4_2) || (zsp_5!=resp5_2) || (zsp_7!=resp7_2))) // Hier wird der Status solange abgerufen, bis keine nderung mehr vorhanden ist
					{
						CALL_FM_RSQ_DATA(&resp4_2, &resp5_2, &resp7_2, &resp3_2);
						zsp_4=resp4_2;
						zsp_5=resp5_2;
						zsp_7=resp7_2;
						zsp_3=resp3_2;
						wdt_reset();
						if((resp3_2>=150) && (resp3_2<=255)&&(stereo!=127)&&(mono!=127))
						{
							lcd_gotoxy(11, 0 );
							lcd_puts("   STEREO");
						}
						if((resp3_2>=20) && (resp3_2<=150)&&(stereo!=127)&&(mono!=127))
						{
							lcd_gotoxy(11, 0 );
							lcd_puts("ST. BLEND");
						}
						if((resp3_2<=1)&&(stereo==127)&&(mono==127))
						{
							lcd_gotoxy(11, 0 );
							lcd_puts("     MONO");
						}
						
						lcd_gotoxy(0, 2 );
						lcd_puts("FM: ");
						utoa( (Sender/100), Buffer, 10 );
						lcd_puts(Buffer);
						lcd_puts(".");
						Buffer_4=Sender;
						utoa(Buffer_4%100,Buffer_2,10);
						if((Buffer_4%100)==0)lcd_puts("00");
						if(Buffer_4%100==5)lcd_puts("05");
						if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
						lcd_puts(Buffer_2);lcd_puts(" MHz ");lcd_puts(" ");
						_delay_ms(40);
						wdt_reset();
						lcd_gotoxy( 13, 3 );
						lcd_puts("RSSI");
						lcd_gotoxy( 18, 3 );
						lcd_puts(" ");
						lcd_gotoxy( 17, 3 );
						itoa( resp4_2, Buffer, 10 );
						lcd_puts(Buffer);
						wdt_reset();
						lcd_gotoxy( 7, 3 );
						lcd_puts("SNR");
						lcd_gotoxy( 11, 3 );
						lcd_puts(" ");
						lcd_gotoxy( 10, 3 );
						itoa( resp5_2, Buffer, 10 );
						lcd_puts(Buffer);
						wdt_reset();
						wdt_reset();
						lcd_gotoxy( 0, 3 );
						lcd_puts("TUN");
						lcd_gotoxy( 3, 3 );
						lcd_puts("    ");
						lcd_gotoxy( 3, 3 );
						itoa( resp7_2, Buffer_2, 10 );
						lcd_puts(Buffer_2);
						if (((resp7_2 < 50) && (resp7_2 > -50)) && (resp4_2 > 15) && (resp5_2 > 10))
						{
							lcd_gotoxy(15,2);
							lcd_puts("TUNED");
						}
						if ((resp7_2 >= 50) || (resp7_2 <= -50) || (resp4_2 <= 15) || (resp5_2 <= 10))
						{
							lcd_gotoxy(15,2);
							lcd_puts("     ");
						}
					}
					
					if (!(PIND&(1<<PD2)) && (merker_5==3))
					{
					merker_5=1;
					eeprom_write_word (&eeFooWordspeicher12, merker_5);
					lcd_gotoxy( 0, 1 );
					lcd_puts("Programm Service(PS)");
					_delay_ms(1000);
					lcd_gotoxy( 0, 1 );
					lcd_puts("                    ");
					wdt_reset();
					}if((merker_5==1)&&(resp7_2 < 50) && (resp7_2 > -50) \
					&& (resp4_2 > 15) && (resp5_2 > 10)){PROGRAMM_SERVICE();
					PS_AUSGABE(PS_OUT,coder,RDS);}
					
					if (!(PIND&(1<<PD2)) && (merker_5==1)) //RDS EINSCHALTEN
					{
						merker_5=2;
						eeprom_write_word (&eeFooWordspeicher12, merker_5);
						lcd_gotoxy( 0, 1 );
						lcd_puts("  Radio Text  (RT)  ");
						_delay_ms(1000);
						lcd_gotoxy( 0, 1 );
						lcd_puts("                    ");
						wdt_reset();
					}
					if((merker_5==2)&&(resp7_2 < 50) && (resp7_2 > -50) \
					 && (resp4_2 > 15) && (resp5_2 > 10))RADIO_TEXT(coder);
					
					if (!(PIND&(1<<PD2)) && (merker_5==2)) //RDS EINSCHALTEN
					{
						merker_5=3;
						eeprom_write_word (&eeFooWordspeicher12, merker_5);
						lcd_gotoxy( 0, 1 );
						lcd_puts("Programm Identifica-");
						_delay_ms(1000);
						wdt_reset();
						lcd_gotoxy( 0, 1 );
						lcd_puts("   tion Code (PI)   ");
						_delay_ms(1100);
						wdt_reset();
						lcd_gotoxy( 0, 1 );
						lcd_puts("                    ");
					}if((merker_5==3)&&(resp7_2 < 50) && (resp7_2 > -50) \
					&& (resp4_2 > 15) && (resp5_2 > 10))PROGRAMM_IDENTIFICATION_CODE();wdt_reset();
					
					if(coder!=0)RDS_CLEAR();

						
		
					
					coder = encode_read_1();
					if(channel_seek<1){Sender += coder *Schritt;}
					
					if (Sender>H_FREQ)
					{Sender=L_FREQ;}
					if (Sender<L_FREQ)
					{Sender=H_FREQ;}
					
					// Suchlauf mode
					if (!(PIND&(1<<PD6)) && (channel_seek==0))
					{
						lcd_gotoxy(0, 0 );
						lcd_puts("FM AUTO   ");
						channel_seek=1;
						eeprom_write_word (&eeFooWordspeicher11, channel_seek);
						_delay_ms(400);
						wdt_reset();
					}
					
					if (!(PIND&(1<<PD6)) && (channel_seek==2))
					{
						lcd_gotoxy(0, 0 );
						lcd_puts("FM MANUELL ");
						channel_seek=0;
						eeprom_write_word (&eeFooWordspeicher11, channel_seek);
						_delay_ms(400);
						wdt_reset();
					}
					
					if (!(PIND&(1<<PD6)) && (channel_seek==1))
					{
						lcd_gotoxy(0, 0 );
						lcd_puts("FM MEMORY");
						channel_seek=2;
						eeprom_write_word (&eeFooWordspeicher11, channel_seek);
						_delay_ms(400);
						wdt_reset();
					}
					if((channel_seek==2)&&(coder!=0)){lcd_clrscr();merker_8=1;}
					while(merker_8==1) // Speicher
					{
						coder = encode_read_1();
						Switch_SM+=coder;
						if(Switch_SM>19)Switch_SM=0;
						if(Switch_SM<0)Switch_SM=19;
						wdt_reset();
						
						// Hier wird dem entsprechendem Speicherplatz, dass mit 0 MHz hinterlegt ist der Anfangswert 87,50 MHz zugewiesen.
						for(int RESET=0; RESET<20; RESET++)
						if(eeprom_read_word(&Speicherplatz[RESET])==0)
						eeprom_write_word(&Speicherplatz[RESET], 8750);
						
						wdt_reset();
						
						// Hier wird zu den freien Speicherpltzen an Stelle des Sendernamens **LEER** hingeschrieben
						for(int Spalte=0; Spalte<20; Spalte++)
						for(int RDS=0; RDS <8; RDS++)
						if(eeprom_read_word(&PS_Save[7-RDS][Spalte])==0)
						{
							eeprom_write_word(&PS_Save[0][Spalte], '*');
							eeprom_write_word(&PS_Save[1][Spalte], '*');
							eeprom_write_word(&PS_Save[2][Spalte], 'L');
							eeprom_write_word(&PS_Save[3][Spalte], 'E');
							eeprom_write_word(&PS_Save[4][Spalte], 'E');
							eeprom_write_word(&PS_Save[5][Spalte], 'R');
							eeprom_write_word(&PS_Save[6][Spalte], '*');
							eeprom_write_word(&PS_Save[7][Spalte], '*');
							wdt_reset();
						}
						
						//Ausgabe von FM MEMORY
						lcd_gotoxy(0, 0 );
						lcd_puts("FM MEMORY");
						wdt_reset();
						
						
						if((Switch_SM<=2)&&(Switch_SM>=0))// Speicherort 1...3
						{
							for(int Spalte=0; Spalte<=2; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte+1);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 0; write <=2; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write+1);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
							}
						}
						wdt_reset();
						
						
						if((Switch_SM<=5)&&(Switch_SM>=3))// Speicherort 4...6
						{
							for(int Spalte=3; Spalte<=5; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte-2);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 3; write <=5; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write-2);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
							}
						}
						wdt_reset();
						
						
						if((Switch_SM<=8)&&(Switch_SM>=6)) // Speicherort 7...9
						{
							for(int Spalte=6; Spalte<=8; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte-5);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 6; write <=8; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write-5);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
							}
						}
						wdt_reset();
						
						
						if((Switch_SM<=11)&&(Switch_SM>=9)) // Speicherort 10...12
						{
							for(int Spalte=9; Spalte<=11; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte-8);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 9; write <=11; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write-8);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
							}
						}
						wdt_reset();
						
						
						if((Switch_SM<=14)&&(Switch_SM>=12))// Speicherort 13...15
						{
							for(int Spalte=12; Spalte<=14; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte-11);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 12; write <=14; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write-11);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
							}
						}
						wdt_reset();
						
						
						if((Switch_SM<=17)&&(Switch_SM>=15))// Speicherort 16...18
						{
							for(int Spalte=15; Spalte<=17; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte-14);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 15; write <=17; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write-14);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
							}
						}
						wdt_reset();
						
						
						if((Switch_SM<=19)&&(Switch_SM>=18)) // Speicherort 19...20
						{
							for(int Spalte=18; Spalte<=19; Spalte++)
							for(int RDS=0; RDS <8; RDS++)
							{
								lcd_gotoxy(19-RDS,Spalte-17);
								lcd_data(eeprom_read_word(&PS_Save[7-RDS][Spalte]));
							}
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							for(int write = 18; write <=19; write++)
							{
								utoa((eeprom_read_word(&Speicherplatz[write])/100.),Buffer,10);
								utoa(write+1,Buffer_5,10);
								lcd_gotoxy(1,write-17);
								lcd_puts("FM");lcd_puts(Buffer_5);lcd_puts(":");lcd_puts(Buffer);

								lcd_puts(".");

								Buffer_4=(eeprom_read_word(&Speicherplatz[write]));
								utoa(Buffer_4%100,Buffer_2,10);
								if((Buffer_4%100)==0)lcd_puts("00");
								if(Buffer_4%100==5)lcd_puts("05");
								if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
								lcd_puts(Buffer_2);lcd_puts(" ");
								lcd_gotoxy(1,3);
								lcd_puts("                    ");
							}
						}
						wdt_reset();
						// Zeiger an LCD
						if((Switch_SM==0)||(Switch_SM==3)||(Switch_SM==6)||(Switch_SM==9)||(Switch_SM==12)||(Switch_SM==15)||(Switch_SM==18))
						{
							lcd_gotoxy(0,1);
							lcd_puts(">");
							lcd_gotoxy(0,2);
							lcd_puts(" ");
							lcd_gotoxy(0,3);
							lcd_puts(" ");
						}
						
						if((Switch_SM==1)||(Switch_SM==4)||(Switch_SM==7)||(Switch_SM==10)||(Switch_SM==13)||(Switch_SM==16)||(Switch_SM==19))
						{
							lcd_gotoxy(0,2);
							lcd_puts(">");
							lcd_gotoxy(0,1);
							lcd_puts(" ");
							lcd_gotoxy(0,3);
							lcd_puts(" ");
						}
						
						if((Switch_SM==2)||(Switch_SM==5)||(Switch_SM==8)||(Switch_SM==11)||(Switch_SM==14)||(Switch_SM==17))
						{
							lcd_gotoxy(0,3);
							lcd_puts(">");
							lcd_gotoxy(0,2);
							lcd_puts(" ");
							lcd_gotoxy(0,1);
							lcd_puts(" ");
						}
						wdt_reset();
						
						if(!(PIND&(1<<PD3)))
						{
							lcd_clrscr();
							lcd_gotoxy(6,1); // Mono
							lcd_puts("SPEICHERN..");
							PROGRAMM_SERVICE();
							eeprom_write_word(&Speicherplatz[Switch_SM], Sender); // bergabe des Sendernamen an EEPROM fr Speicherstelle
							for(int write = 0; write <= 7; write++)
							{
							eeprom_write_word(&PS_Save[write][Switch_SM], PS_OUT[write]);
							if(write==7)load=1;
							}
							_delay_ms(800);
							wdt_reset();
							lcd_clrscr();
						}
						
						if(!(PIND&(1<<PD6)))
						{
							lcd_clrscr();
							lcd_gotoxy(6,1);
							lcd_puts("Laden...");
							Sender = eeprom_read_word(&Speicherplatz[Switch_SM]);
							eeprom_write_word (&eeFooWordspeicher1, Sender);
							_delay_ms(800);
							lcd_clrscr();
							merker_8=0;
							lcd_clrscr();
							lcd_gotoxy(0, 0 );
							lcd_puts("FM MEMORY");
							RDS_CLEAR();
							_delay_ms(10);
							FM_SET_FREQUENCY(Sender);
							_delay_ms(10);
							CALL_FM_RSQ_DATA(&zsp_4, &zsp_5, &zsp_7, &zsp_3);
						}
						
					wdt_reset();	
					}
					
					if((zsp_Sender_AUTO != Sender) && (channel_seek==0))
					{
						zsp_Sender_AUTO=Sender;
						FM_SET_FREQUENCY(Sender);
						wdt_reset();
						lcd_gotoxy(0, 2 );
						lcd_puts("FM: ");
						utoa( (Sender/100), Buffer, 10 );
						lcd_puts(Buffer);
						lcd_puts(".");
						Buffer_4=Sender;
						utoa(Buffer_4%100,Buffer_2,10);
						if((Buffer_4%100)==0)lcd_puts("00");
						if(Buffer_4%100==5)lcd_puts("05");
						if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
						lcd_puts(Buffer_2);lcd_puts(" MHz ");lcd_puts(" ");
						
						eeprom_write_word (&eeFooWordspeicher1, Sender);
						// FM RSQ Information //
						CALL_FM_RSQ_DATA(&zsp_4, &zsp_5, &zsp_7, &zsp_3);
						wdt_reset();
					}
					
					if(channel_seek==1) // Automatisch suchen
					{
					// FM Status
					if (zsp_Sender_AUTO!=Sender)
					{
						GET_FM_UPPERSIDE_FREQ(&Sender);
						//zsp_Sender_AUTO=Sender;
						lcd_gotoxy(0, 0 );
						lcd_puts("FM AUTO   ");
						lcd_gotoxy(0, 2 );
						lcd_puts("FM: ");
						utoa( (Sender/100), Buffer, 10 );
						lcd_puts(Buffer);
						lcd_puts(".");
						Buffer_4=Sender;
						utoa(Buffer_4%100,Buffer_2,10);
						if((Buffer_4%100)==0)lcd_puts("00");
						if(Buffer_4%100==5)lcd_puts("05");
						if(((Buffer_4%100)!=0)&&((Buffer_4%100)!=5))
						lcd_puts(Buffer_2);lcd_puts(" MHz ");lcd_puts(" ");
						_delay_ms(5);
						lcd_gotoxy(15,2);
						lcd_puts("     ");
						eeprom_write_word (&eeFooWordspeicher1, Sender);
						// FM RSQ Information //
						CALL_FM_RSQ_DATA(&zsp_4, &zsp_5, &zsp_7, &zsp_3);
						_delay_ms(5);
						wdt_reset();
					}
					
					if (coder>0) // Automatisch Aufwrts suchen
					{
						SEEK_UP();					
						_delay_ms(5);
						// FM Status
						GET_FM_UPPERSIDE_FREQ(&zsp_Sender_AUTO);
						wdt_reset();
					}
					
					if (coder<0) // Automatisch Abwrts suchen
					{
						SEEK_DOWN();
						_delay_ms(5);
						// FM Status
						GET_FM_DOWNSIDE_FREQ(&zsp_Sender_AUTO);
						wdt_reset();
					}
					}
				}
				eeprom_write_word (&eeFooWordspeicher4, merker_2);	
			}
		}	
	}
}
	
